//   RW Battery
// ==============
// Power : Distribution, Controllers, Batteries & Charging Library
// -Part of the RW Foundations suite of libraries

// Filename: ./include/electro/power/battery.hpp
// -Declarations of the baseline RW Battery sub-library

#pragma once

#include "incls_all.hpp"

namespace rw::electro::power {

//------------------------------------------------------------------------------
/**
 */
class Battery_b : public RW {
 public:
  Battery_b();                                    // default ctor
  explicit Battery_b(std::string const& handle);  // tag-parm'd ctor
};

//------------------------------------------------------------------------------
/**
 */
class Battery : public Battery_b {
 public:
  Battery();                                    // default ctor
  explicit Battery(std::string const& handle);  // tag-parm'd ctor

  inline auto charger() const -> Charger& { return charger_; }

 private:
  unique_ptr<Charger_b> _charger_{make_unique<Charger_b>("battery_charger")};

  Charger& charger_{reference_to<Charger>(_charger_.get())};
};

}  // namespace rw::electro::power

//    --=^=--

// "Now be careful. If you go for a full charge, it can get up there."

// rw_electro_lib.v220205
// Copyright (2022)
// License MIT (Expat) https://opensource.org/licenses/MIT
