//   RW Jsonutils
// ================
// ______
// -The RW Foundational Libraries

// Filename: ./include/rw/json/json_util.hpp
// -Declarations of some baseline RW Jsonutils features

#pragma once

#include "incls_all.hpp"

namespace rw::json {

//------------------------------------------------------------------------------
/** Deserialize file stream into JSON object
 * @param json_ifs the @c std::fstream to deserialize
 * @param close_strm optional flag to close @a json_ifs; default=true
 * @return new, now-populated JSON object
 * @note: this function expects @a json_ifs parm to be a legitimate JSON file;
 * will throw/catch a specialization of std::exception on a parsing error.
 * doesn't re-throw, but @a .clear() 's the return @c Json.
 */
auto fstream_2_json(std::fstream& json_ifs, bool const close_strm = true)  //
    -> Json;

}  // namespace rw::json

//    --=^=--

// "So is it true Sempai? Are robowaifus really better than any human woman?"

// rw_foundations_lib.v220205
// Copyright (2022)
// License MIT(Expat) https://opensource.org/licenses/MIT
