// RW Bumpmaster Project
// =====================
// Imageboard downloader + archiver demo project;  SAVE.EVERYTHING.ANON. :^)

// Filename: ./main_bumpmaster.cpp
// -The program's entry point

#include "incls_all.hpp"

void diag_bumpmaster(Bumpmaster const& bump);
void prt_targ_fields(Json const& json, std::string const& targ_field);

//------------------------------------------------------------------------------
/**
 */
int main() try {
  puts("\n SAVE.EVERYTHING.ANON. :^)");

  Bumpmaster bump{"bumpmaster"};
  diag_bumpmaster(bump);

  puts("\n\n     --=^=--\n\n");

  // TEMP: TEST: output some board's catalog's subjects, by their bump-orders

  vector<string> const catalog_uris{

      "https://alogs.space/robowaifu/catalog.json",
      "https://anon.cafe/christian/catalog.json",
      "https://late.city/late/catalog.json",
      "https://prolikewoah.com/geimu/catalog.json",
      "https://fatchan.org/vr/catalog.json",

  };

  for (auto const& cat_uri : catalog_uris) {  // cycles through all catalog uris

    auto cat_stream = bump.dolldrop().pull(cat_uri);
    if (! is_empty(cat_stream)) {  //

      auto const catalog = fstream_2_json(cat_stream);
      if (! catalog.empty()) {  //

        puts("\n\n     --=^=--\n\n");

        cout << " catalog.size() (num threads) :  '" << catalog.size()
             << "'\n\n";

        // Lynxchan's catalog's thread's JSON field names:
        /*
        "autoSage"
        "cyclic"
        "fileCount"
        "lastBump"
        "locked"
        "markdown"
        "message"
        "mime"
        "page"
        "pinned"
        "postCount"
        "subject"
        "threadId"
        "thumb"
        */
        // for all the threads print (e.g.) 'subject' field & try others, Anon
        string const field_nm{"subject"};
        prt_targ_fields(catalog, field_nm);

        puts("\n\n     --=^=--\n\n");

        // TEST: this statement pretty-prints the catalog's entire JSON data
        //   cout << setw(4) << catalog << '\n';

      } else
        cerr << "\n\n  empty JSON data\n\n";

    } else
      cerr << "\n\n  empty file stream\n\n";
  }

  puts(" ...leaving main()\n");

} catch (runtime_error const& e) {
  cerr << "\n  runtime_error '" << e.what() << "' caught in main()\n\n";

} catch (exception const& e) {
  cerr << "\n  exception '" << e.what() << "' caught in main()\n\n";

} catch (...) {
  cerr << "\n  unknown error caught in main()\n\n";
}

//------------------------------------------------------------------------------
/**
 * @param bump
 */
void diag_bumpmaster(Bumpmaster const& bump) {  //

  prt_tag(bump.t(), "bump");
  prt_tag(bump.board().t(), "bump.board()");
  prt_tag(bump.catalog().t(), "bump.catalog()");
  prt_tag(bump.page().t(), "bump.page()");
  prt_tag(bump.post().t(), "bump.post()");
  prt_tag(bump.site().t(), "bump.site()");
  prt_tag(bump.thread().t(), "bump.thread()");
  prt_tag(bump.waifusearch().t(), "bump.waifusearch()");
  //
  prt_tag(bump.dolldrop().t(), "bump.dolldrop()");
}

//------------------------------------------------------------------------------
/** For each thread in @a catalog, print out specified target field's value data
 * @param catalog the @c Json to search through (an IB catalog)
 * @param targ_field the @c std::string to match against
 * @note: this is mostly just for Lynxchan or JSchan boards, but can be changed
 */
void prt_targ_fields(Json const& catalog, std::string const& targ_field) {
  // NOTE: these C++17 structured bindings represent JSON {key:value} pairs

  // NOTE: a third, outer loop would start here (eg, for vichan etc., boards)
  // ...

  // cycle through all the board catalog's threads (loop 1)
  for (auto const& [implct_idx, thread] : catalog.items()) {  //

    // for each thread, cycle through all of it's fields (loop 2)
    for (auto const& [field_nm, field_dat] : thread.items()) {  //

      // finally, print out data for the thread's matching target field
      if (field_nm == targ_field)
        cout << ' ' << setw(3) << setfill(' ') << (stoi(implct_idx) + 1) << ' '
             << field_nm << "  :  " << field_dat << "\n";
    }
  }
}

//    --=^=--

// "Everyone's talking about IT & the Internet, and how advanced it's getting."

// rw_bumpmaster_demo.v220205
// Copyright (2022)
// License MIT (Expat) https://opensource.org/licenses/MIT
