//   RW Charger
// ==============
// Power : Distribution, Controllers, Batteries & Charging Library
// -Part of the RW Foundations suite of libraries

// Filename: ./src/electro/power/charger.cpp
// -Definitions of the baseline RW Charger library

#include "incls_all.hpp"

namespace rw::electro::power {

//------------------------------------------------------------------------------
Charger_b::Charger_b() : Charger_b{"charger_b_obj"} {}

//------------------------------------------------------------------------------
Charger_b::Charger_b(std::string const& handle) : RW{handle, Type::Charger} {
  stamp("Charger_b()");
}

//------------------------------------------------------------------------------
Charger::Charger() : Charger{"charger_obj"} {}

//------------------------------------------------------------------------------
Charger::Charger(std::string const& handle) : Charger_b{handle} {
  stamp("Charger()");
}

}  // namespace rw::electro::power

//    --=^=--

// "Now be careful. If you go for a full charge, it can get up there."

// rw_electro_lib.v220205
// Copyright (2022)
// License MIT (Expat) https://opensource.org/licenses/MIT
